--Locale
local L_CRIT = " ".. _G["COMBAT_RATING_NAME9"]
local L_HIT = " ".. _G["COMBAT_RATING_NAME6"]
local L_SPEED = " ".. _G["SPEED"]
local L_AP = " ".. _G["ATTACK_POWER_TOOLTIP"]
local L_HASTE = " ".. _G["SPELL_HASTE"]

--Objects Creation
local MS = _G.CreateFrame("Frame", "StatBlock_MeleeStats")
local LDB = _G.LibStub("LibDataBroker-1.1")
MS.AP = LDB:NewDataObject("Melee_AP", {text = "0"..L_AP, value = "0", suffix = L_AP})
MS.Crit = LDB:NewDataObject("Melee_Crit", {text = "0%"..L_CRIT, value = "0%", suffix = L_CRIT})
MS.Hit = LDB:NewDataObject("Melee_Hit", {text = "0%"..L_HIT, value = "0%", suffix = L_HIT})
MS.Speed = LDB:NewDataObject("Melee_Speed", {text = "0.00"..L_SPEED, value = "0.00", suffix = L_SPEED})
MS.Haste = LDB:NewDataObject("Melee_Haste", {text = "0%"..L_HASTE, value = "0%", suffix = L_HASTE})
LDB = nil

-- Upvalues
local format = _G.string.format
local UnitAttackSpeed = _G.UnitAttackSpeed
local UnitAttackPower = _G.UnitAttackPower
local GetCombatRatingBonus = _G.GetCombatRatingBonus
local GetCritChance = _G.GetCritChance
local player = "player"
local two_fp = "%.2f%%"
local single = "%d"
local two = "%.2f"
local two_wep = "%.2f/%.2f"

-- Combat Rating Constants
local CR_HIT_MELEE = 6
local CR_HASTE_MELEE = 18

--Events
MS:RegisterEvent("ITEM_LOCK_CHANGED")
MS:RegisterEvent("PLAYER_LEVEL_UP")
MS:RegisterEvent("PLAYER_AURAS_CHANGED")

--Calculations
MS:SetScript("OnEvent", function()
	local base, pos, neg = UnitAttackPower(player)
	local ap = format(single, base + pos + neg)
	MS.AP.text = ap..L_AP
	MS.AP.value = ap

	local hit = format(two_fp, GetCombatRatingBonus(CR_HIT_MELEE))
	MS.Hit.text = hit..L_HIT
	MS.Hit.value = hit

	local crit = format(two_fp, GetCritChance())
	MS.Crit.text = crit..L_CRIT
	MS.Crit.value = crit

	local haste = format(two_fp, GetCombatRatingBonus(CR_HASTE_MELEE))
	MS.Haste.text = haste..L_HASTE
	MS.Haste.value = haste

	local mh, oh = UnitAttackSpeed(player)
	local speed
	if oh then
		speed = format(two_wep, mh, oh)
	else
		speed = format(two, mh)
	end
	MS.Speed.text = speed..L_SPEED
	MS.Speed.value = speed
end)

